<template>
  <div style="margin: 0 auto">
    <el-container>
      <el-aside width="200px">
<!--        <div class="JKWTree-tree" style="width: 480px;height: 746px;">-->
        <div class="JKWTree-tree" style="height: 746px;">
<!--          <h3> 组织列表</h3>-->
          <el-tree :data="sctreeData" :props="defaultProps" @node-click="schandleNodeClick"></el-tree>
          <el-tree
              :data="treeData"
              :props="defaultProps"
              @node-click="handleNodeClick"></el-tree>
        </div>
      </el-aside>
      <el-container>
        <el-main>

          <!-- 搜索框 -->
          <div class="gva-search-box">
            <el-form ref="elSearchFormRef" :inline="true" :model="searchInfo" class="demo-form-inline" :rules="searchRule" @keyup.enter="onSubmit">

              <!-- 左侧查询输入框 -->
              <el-form-item>
                <el-input v-model="searchInfo.keyword" placeholder="搜索" clearable style="width: 200px;"></el-input>
              </el-form-item>

              <!-- 查询和重置按钮 -->
              <el-form-item>
                <el-button type="primary" icon="search" @click="onSubmit">查询</el-button>
<!--                <el-button icon="refresh" @click="onReset">重置</el-button>-->
<!--                <el-button type="primary" icon="plus" @click="openDialog">新增</el-button>-->
              </el-form-item>
            </el-form>
          </div>

          <div class="gva-table-box">
            <el-table ref="multipleTable"
                      style="width: 100%;height: 580px"
                      border
                      tooltip-effect="dark"
                      :data="tableData"
                      row-key="ID"
                      highlight-current-row="true"
                      @row-click="tableRowClick"
                      @selection-change="handleSelectionChange"
                      :show-overflow-tooltip="true">
              <el-table-column type="selection" width="55"/>
              <el-table-column align="left" label="生产分类" prop="生产分类" width="120" />
              <el-table-column align="left" label="工单编号" prop="工单编号" width="120" />
              <el-table-column align="left" label="产品代号" prop="产品代号" width="120" />
              <el-table-column align="left" label="产品名称" prop="产品名称" width="340" />
              <el-table-column align="left" label="接单日期" prop="接单日期" width="160" />
              <el-table-column align="left" label="交货日期" prop="交货日期" width="160" />
              <el-table-column align="left" label="订单数量" prop="订单数量" width="120" />
              <el-table-column align="left" label="计量单位" prop="计量单位" width="120" />
              <el-table-column align="left" label="客户名称" prop="客户名称" width="200" />
              <el-table-column align="left" label="客户编号" prop="客户编号" width="120" />
              <el-table-column align="left" label="备注" prop="备注" width="400" />
              <el-table-column align="left" label="客户料号" prop="客户料号" width="120" />
              <el-table-column align="left" label="创建用户" prop="创建用户" width="160" />
              <el-table-column align="left" label="创建时间" prop="创建时间" width="160" />
              <el-table-column align="left" label="修改时间" prop="修改时间" width="160" />
              <el-table-column align="left" label="UNIQID" prop="UNIQID" width="120" />
              <el-table-column align="left" label="投料率" prop="投料率" width="120" />
              <el-table-column align="left" label="销售订单号" prop="销售订单号" width="120" />
            </el-table>
            <div class="gva-pagination">
              <el-pagination layout="total, sizes, prev, pager, next, jumper" :current-page="page" :page-size="pageSize" :page-sizes="[10, 30, 50, 100]" :total="total" @current-change="handleCurrentChange" @size-change="handleSizeChange"/>
            </div>
          </div>


            <el-tabs v-model="activeName" type="card" @tab-click="handleClick">

              <el-tab-pane label="工艺资料"  @click="showTable('工艺资料')"  name="first">
                <el-table ref="multipleTable"
                          :show-overflow-tooltip="true"
                          highlight-current-row="true"
                          style="width: 100%;height: 400px" border tooltip-effect="dark" :data="gytableData" row-key="ID" @selection-change="handleSelectionChange">
                  <el-table-column type="selection" width="55" />
                  <el-table-column align="left" label="工单编号" prop="工单编号"  width="100"/>
                  <el-table-column align="left" label="重点工序" prop="重点工序"  width="100"/>
                  <el-table-column align="left" label="工序备注" prop="工序备注"  width="100"/>
                  <el-table-column align="left" label="机组" prop="机组"  width="100"/>
                  <el-table-column align="left" label="小时产能" prop="小时产能"  width="100"/>
                  <el-table-column align="left" label="生产工时" prop="生产工时"  width="100"/>
                  <el-table-column align="left" label="辅助工时" prop="辅助工时"  width="100"/>
                  <el-table-column align="left" label="印刷方式" prop="印刷方式"  width="100"/>
                  <el-table-column align="left" label="版距" prop="版距"  width="100"/>
                  <el-table-column align="left" label="创建用户" prop="创建用户"  width="120"/>
                  <el-table-column align="left" label="创建时间" prop="创建时间"  width="160"/>
                  <el-table-column align="left" label="修改时间" prop="修改时间"  width="160"/>
                  <el-table-column align="left" label="UNIQID" prop="UNIQID"  width="100"/>
                  <el-table-column align="left" label="印件工序及名称" prop="印件工序及名称"  width="340"/>
                </el-table>
              </el-tab-pane>

              <el-tab-pane label="印件资料"  @click="showTable('印件资料')"  name="second">
                <el-table ref="multipleTable"
                          :show-overflow-tooltip="true"
                          highlight-current-row="true"
                          style="width: 100%;height: 400px" border tooltip-effect="dark" :data="yjtableData" row-key="ID" @selection-change="handleSelectionChange">
                  <el-table-column type="selection" width="55" />
                  <el-table-column align="left" label="工单编号" prop="工单编号"  width="100"/>
                  <el-table-column align="left" label="印件号" prop="印件号"  width="100"/>
                  <el-table-column align="left" label="印件代号" prop="印件代号"  width="100"/>
                  <el-table-column align="left" label="印件名称" prop="印件名称"  width="100"/>
                  <el-table-column align="left" label="纸张名称" prop="纸张名称"  width="100"/>
                  <el-table-column align="left" label="投料规格" prop="投料规格"  width="100"/>
                  <el-table-column align="left" label="成品数量" prop="成品数量"  width="100"/>
                  <el-table-column align="left" label="实际投料" prop="实际投料"  width="100"/>
                  <el-table-column align="left" label="投料单位" prop="投料单位"  width="100"/>
                  <el-table-column align="left" label="平张投料" prop="平张投料"  width="100"/>
                  <el-table-column align="left" label="联数" prop="联数"  width="100"/>
                  <el-table-column align="left" label="开数" prop="开数"  width="100"/>
                  <el-table-column align="left" label="创建用户" prop="创建用户"  width="120"/>
                  <el-table-column align="left" label="创建时间" prop="创建时间"  width="160"/>
                  <el-table-column align="left" label="修改时间" prop="修改时间"  width="160"/>
                  <el-table-column align="left" label="UNIQID" prop="UNIQID"  width="100"/>
                </el-table>
              </el-tab-pane>

            </el-tabs>

        </el-main>
      </el-container>
    </el-container>
  </div>
</template>
<script>
//点击按钮显示下方表格
export default {
  data() {
    return {
      currentTable: '',
      activeName: 'first',
      // 其他表格数据...
    };
  },
  methods: {
    showTable(tableName) {
      // console.log(tableName)
      // 根据点击的按钮设置当前展示的表格
      this.currentTable = tableName;
    },
    showTableChange() {
      // 处理表格选中事件
    },
    // 其他方法...
  }
};
</script>

<script setup>
// 全量引入格式化工具 请按需保留
import {createCompany, deleteCompany, deleteCompanyByIds, updateCompany, findCompany, getCompanyList} from '@/api/company'
import { getDictFunc, formatDate, formatBoolean, filterDict, ReturnArrImg, onDownloadFile } from '@/utils/format'
import { ElMessage, ElMessageBox } from 'element-plus'
import { ref, reactive } from 'vue'
import {
  DataList,
  getProduct,
  getProductData,
  Project,
  projectCraft,
  projectPrint,
  workbench
} from "@/api/yunyin/yunying";
defineOptions({name: 'Company'})

// =========== 左侧树侧形结构 ===========
const sctreeData = ref([
  {
    label: '排产进程及参数设置',
    children:[
      {label: '1.计划中工单', number: 1 },
      {label: '2.排程中工单', number: 2 },
      {label: '3.制程中工单', number: 3 },
      {label: '4.已完工工单', number: 4 }
    ],
  }
]);

const treeData = ref([]);
//点击 设备定额及分配参数设置
const schandleNodeClick = async (node) => {
  console.log(node);
  switch (node.number) {
    case 1:
      const Projectdata = await Project();
      tableData.value = Projectdata.data
      // const productCountMap = tableData.value.reduce((countMap, item) => {
      //   const productName = item.产品名称;
      //   countMap[productName] = (countMap[productName] || 0) + 1;
      //   return countMap;
      // }, {});
      // const productCountMapLength = Object.keys(productCountMap).length;
      // console.log(`产品名称总数量：${productCountMapLength}`);
      break;
    case 2:
      break;
    case 3:
      break;
    case 4:
      break;
  }
};
const workbenchdata = async () => {
  try {
    const data = await workbench();
    const rawData = data.data;
    console.log(rawData);

    const dataArray =Object.keys(rawData).map(key => ({
      label: key,
      children: Object.keys(rawData[key]).map(subKey => ({
        label: subKey,
        children: rawData[key][subKey].map(item => ({
          label: item
        }))
      }))
    }));
    treeData.value = dataArray;
    // console.log(dataArray);
  } catch (error) {
    console.error(error);
  }
};
workbenchdata();

//点击左侧树形获取列表
const tableData = ref([])
const handleNodeClick = async (node) => {
  const custom_code = node.label; // 假设你想使用节点的 label 作为 custom_code
  console.log(custom_code);
};


//印件资料
const yjtableData = reactive([])
//工艺资料
const gytableData = reactive([])

const tableRowClick = async (row) => {
  //点击表格获取 产品编号
  // const Gd_gdbh = row.工单编号;
  const Gd_gdbh = '2401101';
  // console.log(Gd_gdbh);
  const gyres = await projectCraft({Gd_gdbh:Gd_gdbh});//接口
  gytableData.splice(0, gytableData.length, ...gyres.data);//工艺资料表格
  const yjres = await projectPrint({Gd_gdbh:Gd_gdbh});//接口
  yjtableData.splice(0, yjtableData.length, ...yjres.data);//印件资料表格
};




// 自动化生成的字典（可能为空）以及字段
const formData = ref({
  address: '',
  image: '',
  name: '',
})

// 验证规则
const rule = reactive({
})

const searchRule = reactive({
  createdAt: [
    { validator: (rule, value, callback) => {
        if (searchInfo.value.startCreatedAt && !searchInfo.value.endCreatedAt) {
          callback(new Error('请填写结束日期'))
        } else if (!searchInfo.value.startCreatedAt && searchInfo.value.endCreatedAt) {
          callback(new Error('请填写开始日期'))
        } else if (searchInfo.value.startCreatedAt && searchInfo.value.endCreatedAt && (searchInfo.value.startCreatedAt.getTime() === searchInfo.value.endCreatedAt.getTime() || searchInfo.value.startCreatedAt.getTime() > searchInfo.value.endCreatedAt.getTime())) {
          callback(new Error('开始日期应当早于结束日期'))
        } else {
          callback()
        }
      }, trigger: 'change' }
  ],
})

const elFormRef = ref()
const elSearchFormRef = ref()

// =========== 表格控制部分 ===========
const page = ref(1)
const total = ref(0)
const pageSize = ref(10)
const searchInfo = ref({})

// 重置
const onReset = () => {
  searchInfo.value = {}
  getTableData()
}

// 搜索
const onSubmit = () => {
  elSearchFormRef.value?.validate(async(valid) => {
    if (!valid) return
    page.value = 1
    pageSize.value = 10
    getTableData()
  })
}

// 分页
const handleSizeChange = (val) => {
  pageSize.value = val
  getTableData()
}

// 修改页面容量
const handleCurrentChange = (val) => {
  page.value = val
  getTableData()
}

// 查询
const getTableData = async() => {
  const table = await getCompanyList({ page: page.value, pageSize: pageSize.value, ...searchInfo.value })
  if (table.code === 0) {
    tableData.value = table.data.list
    total.value = table.data.total
    page.value = table.data.page
    pageSize.value = table.data.pageSize
  }
}

getTableData()

// ============== 表格控制部分结束 ===============

// 获取需要的字典 可能为空 按需保留
const setOptions = async () =>{
}

// 获取需要的字典 可能为空 按需保留
setOptions()


// 多选数据
const multipleSelection = ref([])
// 多选
const handleSelectionChange = (val) => {
  multipleSelection.value = val
}

// 行为控制标记（弹窗内部需要增还是改）
const type = ref('')

//修改
const updateCompanyFunc = async (row) => {
  console.log(row);
  dialogFormVisible.value = true;
};

// 弹窗控制标记
const dialogFormVisible = ref(false)

// 查看详情控制标记
const detailShow = ref(false)

// 打开详情弹窗
const openDetailShow = () => {
  detailShow.value = true
}

// 打开详情
const getDetails = async (row) => {
  // 打开弹窗
  const res = await findCompany({ ID: row.ID })
  if (res.code === 0) {
    formData.value = res.data.recompany
    openDetailShow()
  }
}

// 关闭详情弹窗
const closeDetailShow = () => {
  detailShow.value = false
  formData.value = {
    address: '',
    image: '',
    name: '',
  }
}

// 打开弹窗
const openDialog = () => {
  type.value = 'create'
  dialogFormVisible.value = true
}

// 关闭弹窗
const closeDialog = () => {
  dialogFormVisible.value = false
  formData.value = {
    address: '',
    image: '',
    name: '',
  }
}
// 弹窗确定
const enterDialog = async () => {
  elFormRef.value?.validate( async (valid) => {
    if (!valid) return
    let res
    switch (type.value) {
      case 'create':
        res = await createCompany(formData.value)
        break
      case 'update':
        res = await updateCompany(formData.value)
        break
      default:
        res = await createCompany(formData.value)
        break
    }
    if (res.code === 0) {
      ElMessage({
        type: 'success',
        message: '创建/更改成功'
      })
      closeDialog()
      getTableData()
    }
  })
}
</script>
<style>
.JKWTree-container {
  display: flex;
}
.JKWTree-tree {
  width: 300px;
  background-color: #fff;
  padding: 10px;
  margin-right: 20px;
}

.JKWTree-tree h3 {
  font-size: 15px;
  font-weight: 700;
  margin: 10px 0;
}
.JKWTree-content {
  flex: 1;
}
/* 选中某行时的背景色*/
.el-table__body tr.current-row>td {
  background: #ff80ff !important;
}
</style>